#include <boost/extension/extension.hpp>
#include <boost/extension/factory.hpp>
#include <boost/extension/type_map.hpp>
#include <boost/property_tree/ptree.hpp>
#include <boost/property_tree/xml_parser.hpp>

#include <mysql++/mysql++.h>
#include <sys/utsname.h>

#include <plugins/plugin.hpp>
#include <ndds/ndds_cpp.h>
#include "snort_dds.h"
#include "snort_ddsSupport.h"

#include <iostream>

#ifndef SYSCONFDIR
#  define SYSCONFDIR ""
#endif

class snort_alertListener : public DDSDataReaderListener {
  public:
	snort_alertListener();

    virtual void on_requested_deadline_missed(
        DDSDataReader* /*reader*/,
        const DDS_RequestedDeadlineMissedStatus& /*status*/) {}

    virtual void on_requested_incompatible_qos(
        DDSDataReader* /*reader*/,
        const DDS_RequestedIncompatibleQosStatus& /*status*/) {}

    virtual void on_sample_rejected(
        DDSDataReader* /*reader*/,
        const DDS_SampleRejectedStatus& /*status*/) {}

    virtual void on_liveliness_changed(
        DDSDataReader* /*reader*/,
        const DDS_LivelinessChangedStatus& /*status*/) {}

    virtual void on_sample_lost(
        DDSDataReader* /*reader*/,
        const DDS_SampleLostStatus& /*status*/) {}

    virtual void on_subscription_matched(
        DDSDataReader* /*reader*/,
        const DDS_SubscriptionMatchedStatus& /*status*/) {}

    virtual void on_data_available(DDSDataReader* reader);

  private:
    std::map<char *,host_info> hostinfo_map_;  
    std::map<std::string,int> rowcount_map_;
    mysqlpp::Connection conn_;
    std::string database_server_;
 	std::string database_name_;
   	std::string database_user_;
   	std::string database_password_;
   	
};


class snort : public plugin {

public:
	snort(DDSDomainParticipant *participant);
	virtual void receive_information(void);

private:
    //DDS stuff
    DDSDomainParticipant *participant_;
    DDSSubscriber *subscriber_;
    DDSTopic *topic_;
    snort_alertListener *reader_listener_;
    DDSDataReader *reader_;
    DDS_ReturnCode_t retcode_;
    const char *type_name_;
    DDS_Duration_t receive_period_;
	std::string qos_file_;

};


BOOST_EXTENSION_TYPE_MAP_FUNCTION {
	using namespace boost::extensions;
	std::map<std::string, factory<plugin, DDSDomainParticipant *> > &plugin_factories(types.get());
	plugin_factories["snort"].set<snort>();
}



